﻿using System;
using System.Linq;
using System.Activities;
using System.Activities.Statements;
using System.Activities.Hosting;
using System.ServiceModel;
using System.ServiceModel.Activities;
using System.ServiceModel.Channels;
using nsoftware.Wcf.FTP;
using System.ServiceModel.Activities.Description;

namespace FtpProcessor {

  [DataContract(Namespace = "urn:ftp-processor:request")]
  public class ProcessRequest
  {
    [DataMember(Order = 1)]
    public int ID;
    [DataMember(Order = 2)]
    public String Sender;
  }



  class Program {
    static void Main(string[] args) {
      WorkflowServiceHost host = null; 
      try {
        host = new WorkflowServiceHost(new Workflow1());
        Binding binding = GetBinding();
        host.AddServiceEndpoint("IFtpProcessor", binding, "ftp://ServerIP");
        host.Open();
        Console.WriteLine("Host ready.");
        Console.ReadLine();
      } catch ( Exception ex ) {
        Console.WriteLine("Error creating WorkflowServiceHost: {0}", ex);
      } finally {
        if ( host != null ) {
          if ( host.State == CommunicationState.Faulted ) {
            host.Abort();
          } else {
            host.Close();
          }
        }
      }
    }
    static Binding GetBinding() {
      FTPBinding binding = new FTPBinding();
      binding.User = "user";
      binding.Password = "password";
      binding.RemotePath = "process";
      binding.FileMask = "request*.xml";
      binding.Delete = true;
      binding.SSLAcceptServerCertAcceptAny = true;
      binding.TransportLogType = FTPLogTypes.ltFile;
      binding.TransportLogLocation = @"c:\ftp.log";
      binding.TransportLogMode = FTPLogModes.lmDebug;
      binding.PollingInterval = 10;
      return binding;
    }
  }
}
